
#include "usart.h"
#include "debug.h"

void DMA1_Channel7_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

//2~8 ʼ
typSerial2to8 Serials[1] =
{
        {
                USART2, RCC_APB1Periph_USART2,
                RCC_APB2Periph_GPIOA, GPIOA, GPIO_Pin_2,
                RCC_APB2Periph_GPIOA, GPIOA, GPIO_Pin_3,
                RCC_AHBPeriph_DMA1, DMA1_Channel7, DMA1_FLAG_TC7, DMA1_Channel6, DMA1_FLAG_TC6,
                0, 1, 9600, 0, 5, 0, 0, {0}
        }
};

u16 i = 0;

//SRC_BUFΪDMAԴݴ洢ڲFLASH
u8 TxBuffer1[USART_MAX_LEN]=
{
        0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09
};

/*******************************************************************************
* Function Name  : USARTx_CFG
* Description    : Initializes the USART2 & USART3 peripheral.
* Input          : None
* Return         : None
*******************************************************************************/
void USARTx_CFG(void)
{

    GPIO_InitTypeDef  GPIO_InitStructure={0};
    USART_InitTypeDef USART_InitStructure={0};

    //ʹܿGPIOAUSART2ʱ
    RCC_APB2PeriphClockCmd(Serials[0].RCC_APB2Periph_GPIOTx , ENABLE);
    RCC_APB2PeriphClockCmd(Serials[0].RCC_APB2Periph_GPIORx , ENABLE);
    RCC_APB1PeriphClockCmd(Serials[0].RCC_APB1Periph_USARTn, ENABLE);

    //3ӦGPIOųʼ
    /* USART3 TX-->B.10  RX-->B.11 */
    GPIO_InitStructure.GPIO_Pin = Serials[0].GPIO_Pin_Tx;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(Serials[0].GPIO_Tx, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = Serials[0].GPIO_Pin_Rx;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(Serials[0].GPIO_Rx, &GPIO_InitStructure);


    //3ʼ
    USART_DeInit(Serials[0].USARTn);
    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(Serials[0].USARTn, &USART_InitStructure);

    USART_Cmd(Serials[0].USARTn, ENABLE);  //ʹܴ2
}

/*******************************************************************************
* Function Name  : DMA_INIT
* Description    : Configures the DMA for USART3.
* Input          : None
* Return         : None
*******************************************************************************/
void DMA_INIT(void)
{
    DMA_InitTypeDef   DMA_InitStructure={0};
    NVIC_InitTypeDef  NVIC_InitStructure={0};

    RCC_AHBPeriphClockCmd(Serials[0].RCC_AHBPeriph, ENABLE);                 //ʹܿDMAʱ

    DMA_DeInit(Serials[0].DMA_Tx);
    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)(&USART2->DATAR);        /*DMAԴ3ݼĴַ*/
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)TxBuffer1;                   /*ڴַ(Ҫıָ)*/
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;                       /*򣺴ڴ浽*/
    DMA_InitStructure.DMA_BufferSize = USART_MAX_LEN;                        /*СDMA_BufferSize=TxSize1*/
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;         /*ַ*/
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;                  /*ڴַ*/
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;  /*ݵλ ֽ*/
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;          /*ڴݵλ ֽ*/
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;                            /*DMAģʽģʽֻһΡע⣺ADɼ֮ʱҪóѭģʽ*/
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;                  /*ȼǳ*/
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                             /*ֹڴ浽ڴĴ*/
    DMA_Init(Serials[0].DMA_Tx, &DMA_InitStructure);                         /*DMA12ͨ*/

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    DMA_ITConfig(Serials[0].DMA_Tx, DMA_IT_TC, ENABLE);  //ʹDMAж

    DMA_Cmd(Serials[0].DMA_Tx,ENABLE);  //ʹDMA
}

void USART_DMA_Init(void)
{
    USARTx_CFG();
    DMA_INIT();
    USART_DMACmd(Serials[0].USARTn, USART_DMAReq_Tx, ENABLE);
}

void DMA1_Channel7_IRQHandler(void)
{
    if(DMA_GetITStatus(DMA1_IT_TC7))
    {
        printf("USART DMA complete\r\n");
        for(i=0;i<USART_MAX_LEN;i++)
        {
                printf("0x%02x\r\n",TxBuffer1[i]);
        }
        DMA_ClearITPendingBit(DMA1_IT_TC7); //ȫжϱ־
    }
}
